from read_baseline_data import *
from read_chirp_data import *
from utility import *
import matplotlib.pyplot as plt
import numpy as np


def chirp_eod_plot(df_map, eod, times):
	#die äußere Schleife geht für alle Keys durch und somit durch alle dfs
	#die innnere Schleife bildet die 16 Wiederholungen einer Frequenz ab

	for i in df_map.keys():
		freq = list(df_map[i]) 
		fig,axs = plt.subplots(2, 2, sharex = True, sharey = True)

		for idx, k in enumerate(freq):
			ct = times[k]
			e1 = eod[k]
			zeit = e1[0]
			eods = e1[1]
	
			if idx <= 3:
				axs[0, 0].plot(zeit, eods, color= 'blue', linewidth = 0.25)
				axs[0, 0].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
			elif 4<= idx <= 7:
				axs[0, 1].plot(zeit, eods, color= 'blue', linewidth = 0.25)
				axs[0, 1].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
			elif 8<= idx <= 11:
				axs[1, 0].plot(zeit, eods, color= 'blue', linewidth = 0.25)
				axs[1, 0].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
			else: 
				axs[1, 1].plot(zeit, eods, color= 'blue', linewidth = 0.25)
				axs[1, 1].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)

	fig.suptitle('EOD for chirps', fontsize = 16)
	axs[0,0].set_ylabel('Amplitude [mV]') 
	axs[0,1].set_xlabel('Amplitude [mV]')
	axs[1,0].set_xlabel('Time [ms]')
	axs[1,1].set_xlabel('Time [ms]')
	plt.close()



def cut_chirps(freq, eod, times):
	ls_mod = []
	ls_beat = []
	for k in freq: 
		e1 = eod[k]
		zeit = np.asarray(e1[0])
		ampl = np.asarray(e1[1])

		ct = times[k]
		for chirp in ct:
			time_cut = zeit[(zeit > chirp-10) & (zeit < chirp+10)]
			eods_cut = ampl[(zeit > chirp-10) & (zeit < chirp+10)]
			beat_cut = ampl[(zeit > chirp-55) & (zeit < chirp-10)]
		
			chirp_mod = np.std(eods_cut) #Std vom Bereich um den Chirp
			ls_mod.append(chirp_mod)
			ls_beat.extend(beat_cut)

	beat_mod = np.std(ls_beat) #Std vom Bereich vor dem Chirp
	plt.figure()
	plt.scatter(np.arange(0,len(ls_mod),1), ls_mod)
	plt.scatter(np.arange(0,len(ls_mod),1), np.ones(len(ls_mod))*beat_mod, color = 'violet')
	plt.close()
	return(ls_mod, beat_mod)



def plot_std_chirp(sort_df, df_map, chirp_spikes, ls_mod):
	plt.figure()	
	dct_phase = {}
	num_bin = 12
	phase_vec = np.arange(0, 1+1/num_bin, 1/num_bin)

	for i in sort_df:
		freq = list(df_map[i])
		dct_phase[i] = []
		for k in freq:
			for phase in chirp_spikes[k]:
				dct_phase[i].append(phase[1])

		plt.scatter(dct_phase[i], ls_mod[i])
	plt.title('Change of std depending on the phase where the chirp occured')
	plt.close()

